/* PLAN - route finding */
%%% Backtracking DFS Search
:- dynamic(p/1).
:- dynamic(q/2).

d(s,g).
d(s,n1).
d(s,n2).
d(n1,n2).
d(n1,n4).
d(n1,n3).
d(n2,n3).
d(n3,n4).
d(n3,n5).
d(n4,n5).
d(n4,n6).
d(n5,n6).
d(n6,g).

nodes([s,n1,n2,n3,n4,n5,n6]).


%%% symmetric closure d/2 
     route(X,Y):- d(X,Y).
     route(X,Y):- d(Y,X).
          
%%% Transitive closure
     path(G,G,T,T):- !.
     path(C,G,W,T):- 
          route(C,NC),
          not(member(NC,W)),
          path(NC,G,[NC|W],T).

%%% inicjacja szukania
     plan(Start,Goal,Path):-
          path(Goal,Start,[Goal],Path).                           
     
                                                  
%%% Find all plans from 's' to 'g'.
     fap(Plans) :- findall(Trasa, plan(s,g,Trasa),Plans).

%%% Find all plans and assert; p(<plan>).
     fap-assert:- plan(s,g,Plan), assert(p(Plan)), fail.
     fap-assert.

%%% Count: zliczanie krotnosci wezla w planach.
     count(N,_):- p(P), member(N,P), add(N), fail.
     count(N,K):- q(N,K).

add(N):- \+ q(N,_),!, assert(q(N,1)).
add(N):- retract(q(N,K)), K1 is K+1, assert(q(N,K1)).

     countall:- nodes(LN), select(N,LN,_), count(N,K), write('node: '), write(N), write('  in: '), write(K),nl.
